> **Note**
> This file contains uncategorized resources. Not all the information presented in this file have yet been validated. Do not refer to any entries in this file other than discussions relating to aspects directly related to the file itself. Suggestions, improvements and submissions of new resources are welcome.

> Thanks to all the contributors! :green_heart:

# AI

## Companies

- https://comma.ai
- Mistral (LLMs)

## Researches

- Alpaca AI: https://arxiv.org/pdf/2302.13971v1.pdf

## Roadmaps

- https://i.am.ai/roadmap
- https://github.com/AMAI-GmbH/AI-Expert-Roadmap

## Software

- llama.cpp
- alpaca.cpp
- https://github.com/OpenBMB/ChatDev

## Online tools

- https://perchance.org/ai-story-generator

## Tools

- https://github.com/irsat000/cai-tools

# Digital design

- For UI designers: https://ianli.github.io/so-you-need-a-typeface/
  > SO YOU NEED A TYPEFACE 2.0 is an interactive way to choose fonts for your projects. It is a web recreation of the infographic poster designed by Julian Hansen. Ian Li recreated the poster into a dynamic web page using HTML, CSS, and jQuery.

# Programming

## Chess programming

- "If there's anyone who wants to make their own chess engine, this is a good place to start": https://www.chessprogramming.org/Main%5FPage

## Computer science

- "Structure and Interpretation of Computer Programs" by Harold Abelson et al.: https://web.mit.edu/6.001/6.037/sicp.pdf
- "Compilers: Principles, Techniques, And Tools" by Alfred Vaino Aho et al.: https://archive.org/details/aho-compilers-principles-techniques-and-tools-2e%5F202203/
- "A curated list of awesome transpilers. aka source-to-source compilers": https://github.com/milahu/awesome-transpilers
- Molly Rocket: "The Only Unbreakable Law": [YouTube link](https://www.youtube.com/watch?v=5IUj1EZwpJY)

## Educational comics

- Programming comics by Julia Evans: short guides on various topics, including Linux and CSS, and not only programming: https://wizardzines.com/comics/

## Language: Bash scripting

### Manuals

- https://www.gnu.org/savannah-checkouts/gnu/bash/manual/bash.html

### Tutorials

- https://ryanstutorials.net/bash-scripting-tutorial

### Interpreters

- https://craftinginterpreters.com
- Alex Gaynor: "So you want to write an interpreter?": [YouTube link](https://www.youtube.com/watch?v=LCslqgM48D4)

## Language: C

- https://devtut.github.io/c/
- Undefined behavior in C, from StackOverflow: https://devtut.github.io/c/undefined-behavior.html
- "How to C in 2016", "This is a draft I wrote in early 2015": https://matt.sh/howto-c
- https://musl.libc.org
  > musl is an implementation of the C standard library built on top of the Linux system call API, including interfaces defined in the base language standard, POSIX, and widely agreed-upon extensions. musl is lightweight, fast, simple, free, and strives to be correct in the sense of standards-conformance and safety.
- "If you really want to write everything perfectly, simply memorize their thousand simple examples": https://wiki.sei.cmu.edu/confluence/display/c/SEI+CERT+C+Coding+Standard

### Compilers

- For learning about simple C compilers: https://github.com/rui314/chibicc
- A linker useful for compiling browsers: https://github.com/rui314/mold

### Meta

- [IOCCC](https://ioccc.org)
- [ilyakurdyukov's IOCCC practice programs](https://github.com/ilyakurdyukov/ioccc/tree/main/practice)
- [Underhanded C contest](https://en.wikipedia.org/wiki/Underhanded%5FC%5FContest)
- program cdecl: https://github.com/paul-j-lucas/cdecl

## Language: C++

- ":book: Modern C++ Tutorial: C++11/14/17/20 On the Fly": https://github.com/changkun/modern-cpp-tutorial
- "A curated list of awesome header-only C++ libraries": https://github.com/p-ranav/awesome-hpp
- "Reproducible random number generation for parallel computations": https://github.com/msu-sparta/OpenRAND/

## Language: JavaScript

### Tools

- "Multiline JavaScript string converter": https://jsstringconverter.bbody.io/

## Language: Python 3

### Documentations

- https://docs.python.org/3/library/struct.html

### Cheat sheets

- https://mypy.readthedocs.io/en/stable/cheat%5Fsheet%5Fpy3.html

## Math behind programming

- CodingQuest: "The Wave Function Collapse algorithm": [YouTube link](https://www.youtube.com/watch?v=qRtrj6Pua2A)

## POSIX

- > Although now quite impractical to rectify, clearly POSIX made a mistake when defining the line -- as evidence by the number of questions regarding this issue. A line should have been defined as zero or more characters terminated by &lt;eol&gt;, &lt;eof&gt;, or &lt;eol&gt;&lt;eof&gt;. Parser complexity is not a valid concern. Complexity, wherever possible, should be moved from the programmers head and into the library.

  \- [source](https://stackoverflow.com/questions/729692/why-should-text-files-end-with-a-newline#comment94173047_729795)

## Roadmaps

- Developer Roadmaps: "roadmap.sh is a community effort to create roadmaps, guides and other educational content to help guide developers in picking up a path and guide their learnings.": https://roadmap.sh
- i.am.ai, AI Expert Roadmap: "Roadmap to becoming an Artificial Intelligence Expert in 2022": https://i.am.ai/roadmap
- Awesome Roadmaps: "A curated list of roadmaps, mostly about software development, which give you a clear route to improve your knowledge or skills." https://github.com/liuchong/awesome-roadmaps

# Retrocomputing

- https://www.delorie.com/djgpp/ : "DJGPP is a complete 32-bit C/C++ development system for Intel 80386 (and higher) PCs running DOS. It includes ports of many GNU development utilities. The development tools require a 80386 or newer computer to run, as do the programs they produce. In most cases, the programs it produces can be sold commercially without license or royalties."
- https://retrocomputing.stackexchange.com/questions/1811/which-linux-or-bsd-distributions-do-still-support-i386-i486-or-i586-cpus/4364#4364

# Services

## Web hosting

### Databases

- https://planetscale.com - has generous free tier

### Static web hosting

- https://vercel.com - has generous free tier

## Anonymous/temporary email services

- https://temp-mail.org - free disposal email
- https://www.sharklasers.com - free disposal email (other kind)

## Anonymous file storages

- https://uguu.se
- https://patchouli.moe
- https://catbox.moe

## Temporary and/or anonymous file storages

- https://litterbox.catbox.moe

## Anti-paywalls

- https://archive.org
- https://12ft.io

## Related to online/remote AI

- https://zzzcode.ai
- https://poe.com
- https://phind.com

## Image AI generators

- Stable Diffusion family
  - instance family https://stable-diffusion.site/webui-online/

## Time

- https://www.epochconverter.com
- https://time.is

## Games

- "Save Editor, tool to edit a game's save file. (I haven't tried this one myself.)" : https://www.saveeditonline.com/

## F(L)OSS instances
- https://projectsegfau.lt/instances : "Open-source development and hosted services." : Invidious, Piped, Libreddit, Nitter, AnonymousOverflow, BreezeWiki, GotHub, HyperPipe, Rimgo, Safetwitch, Scribe, SimplyTranslate, Teddit
- https://8mb.video : "Perfectly compressed files just under 8MB" (and beyond)
- https://disroot.org : FOSS services

# Unix

## Linux

- Learn Linux TV: "Linux Crash Course - Easy Terminal Commands for Inspecting Hardware": [YouTube link](https://www.youtube.com/watch?v=oGyJr-iUwt8)
- Jacob Pradels: "No really, how does Linux run executables?": [YouTube link](https://www.youtube.com/watch?v=Ia5jyz8sOCM)
- https://github.com/topgrade-rs/topgrade : "Upgrade all the things"
  > Keeping your system up to date usually involves invoking multiple package managers. This results in big, non-portable shell one-liners saved in your shell. To remedy this, Topgrade detects which tools you use and runs the appropriate commands to update them.

### Linux subsystems for Windows

- Cygwin
- MSYS2
- MinGW

## OpenBSD

- OpenBSD Handbook: ["OpenBSD for Linux users"](https://www.openbsdhandbook.com/openbsd_for_linux_users/)

# Web

## Cheat sheets

- "Password Storage Cheat Sheet" by OWASP: https://cheatsheetseries.owasp.org/cheatsheets/Password%5FStorage%5FCheat%5FSheet.html

## SSL

- https://certbot.eff.org/ : For those who own a website
  > Certbot is a free, open source software tool for automatically using Let's Encrypt certificates on manually-administrated websites to enable HTTPS.
  > Certbot is made by the Electronic Frontier Foundation (EFF), a 501(c)3 nonprofit based in San Francisco, CA, that defends digital privacy, free speech, and innovation.

## Tools

- https://github.com/nabla-c0d3/sslyze : "SSLyze is a fast and powerful SSL/TLS scanning tool and Python library."; "SSLyze can analyze the SSL/TLS configuration of a server by connecting to it, in order to ensure that it uses strong encryption settings (certificate, cipher suites, elliptic curves, etc.), and that it is not vulnerable to known TLS attacks (Heartbleed, ROBOT, OpenSSL CCS injection, etc.)."
- https://github.com/cfenollosa/bashblog : "A single Bash script to create blogs. Download, run, write, done!"
- https://forgefed.org
  > ForgeFed is a federation protocol for software forges and code collaboration tools for the software development lifecycle and ecosystem. This includes repository hosting websites, issue trackers, code review applications, and more. ForgeFed provides a common substrate for people to create interoperable code collaboration websites and applications.

## Tutorials

- https://landchad.net : "a site dedicated to turning internet peasants into Internet Landlords by showing them how to setup websites, email servers, chat servers and everything in between."

## Other

- https://basedflare.com : BasedFlare: Sovereign solutions for DNS, CDN, WAF, and DDoS mitigation.

# Other

- https://www.toptal.com/developers/gitignore/ : a .gitignore generator
- https://learnxinyminutes.com/ : Learn X in Y minutes: "Take a whirlwind tour of your next favorite language. Community-driven!"
- https://muted.io/piano-chords/ : A piano chord player that makes it easy to hear and visualize piano chords online.
